Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2528)
@@ -19,5 +19,6 @@
    PRIVATE
 
-   PUBLIC   p4z_sink    ! called in p4zbio.F90
+   PUBLIC   p4z_sink         ! called in p4zbio.F90
+   PUBLIC   p4z_sink_init    ! called in trcsms_pisces.F90
 
    !! * Shared module variables
@@ -31,7 +32,4 @@
      sinkcal, sinksil,    &    !: CaCO3 and BSi sinking fluxes
      sinkfer                   !: Small BFe sinking flux
-
-   REAL(wp) ::   &
-     xstep , xstep2            !: Time step duration for biology
 
    INTEGER  :: &
@@ -71,7 +69,7 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -97,5 +95,5 @@
       REAL(wp) :: zdiv , zdiv1, zdiv2, zdiv3, zdiv4, zdiv5
       REAL(wp) :: zval1, zval2, zval3, zval4
-#if defined key_trc_diaadd
+#if defined key_diatrc
       REAL(wp) :: zrfact2
       INTEGER  :: ik1
@@ -106,12 +104,6 @@
       !!---------------------------------------------------------------------
 
-      IF( ( kt * jnt ) == nittrc000  )  THEN 
-          CALL p4z_sink_init   ! Initialization (first time-step only)
-          xstep  = rfact2 / rday      ! Time step duration for biology
-          xstep2 = rfact2 /  2.
-      ENDIF
-
-!     Initialisation of variables used to compute Sinking Speed
-!     ---------------------------------------------------------
+      !     Initialisation of variables used to compute Sinking Speed
+      !     ---------------------------------------------------------
 
        znum3d(:,:,:) = 0.e0
@@ -120,6 +112,6 @@
        zval3 = 1. + xkr_eta
 
-!     Computation of the vertical sinking speed : Kriest et Evans, 2000
-!     -----------------------------------------------------------------
+     !     Computation of the vertical sinking speed : Kriest et Evans, 2000
+     !     -----------------------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -128,9 +120,9 @@
                IF( tmask(ji,jj,jk) /= 0.e0 ) THEN
                   znum = trn(ji,jj,jk,jppoc) / ( trn(ji,jj,jk,jpnum) + rtrn ) / xkr_massp
-! -------------- To avoid sinking speed over 50 m/day -------
+                  ! -------------- To avoid sinking speed over 50 m/day -------
                   znum  = MIN( xnumm(jk), znum )
                   znum  = MAX( 1.1      , znum )
                   znum3d(ji,jj,jk) = znum
-!------------------------------------------------------------
+                  !------------------------------------------------------------
                   zeps  = ( zval1 * znum - 1. )/ ( znum - 1. )
                   zfm   = xkr_frac**( 1. - zeps )
@@ -150,7 +142,6 @@
       wscal(:,:,:) = MAX( wsbio3(:,:,:), 50. )
 
-
-!   INITIALIZE TO ZERO ALL THE SINKING ARRAYS
-!   -----------------------------------------
+      !   INITIALIZE TO ZERO ALL THE SINKING ARRAYS
+      !   -----------------------------------------
 
       sinking (:,:,:) = 0.e0
@@ -160,7 +151,6 @@
       sinksil (:,:,:) = 0.e0
 
-!   Compute the sedimentation term using p4zsink2 for all
-!   the sinking particles
-!   -----------------------------------------------------
+     !   Compute the sedimentation term using p4zsink2 for all the sinking particles
+     !   -----------------------------------------------------
 
       CALL p4z_sink2( wsbio3, sinking , jppoc )
@@ -170,7 +160,6 @@
       CALL p4z_sink2( wscal , sinkcal , jpcal )
 
-!  Exchange between organic matter compartments due to
-!  coagulation/disaggregation
-!  ---------------------------------------------------
+     !  Exchange between organic matter compartments due to coagulation/disaggregation
+     !  ---------------------------------------------------
 
       zval1 = 1. + xkr_zeta
@@ -185,8 +174,8 @@
 
                   znum = trn(ji,jj,jk,jppoc)/(trn(ji,jj,jk,jpnum)+rtrn) / xkr_massp
-! -------------- To avoid sinking speed over 50 m/day -------
+                  !-------------- To avoid sinking speed over 50 m/day -------
                   znum  = min(xnumm(jk),znum)
                   znum  = MAX( 1.1,znum)
-!------------------------------------------------------------
+                  !------------------------------------------------------------
                   zeps  = ( zval1 * znum - 1.) / ( znum - 1.)
                   zdiv  = MAX( 1.e-4, ABS( zeps - zval3) ) * SIGN( 1., zeps - zval3 )
@@ -199,6 +188,6 @@
                   zsm   = xkr_frac**xkr_eta
 
-!    Part I : Coagulation dependant on turbulence
-!    ----------------------------------------------
+                  !    Part I : Coagulation dependant on turbulence
+                  !    ----------------------------------------------
 
                   zagg1 = ( 0.163 * trn(ji,jj,jk,jpnum)**2               &
@@ -207,5 +196,5 @@
                      &            * (zfm*xkr_mass_max**2-xkr_mass_min**2)                  &
                      &            * (zeps-1.)**2/(zdiv2*zdiv3))            &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)       &
 # endif
@@ -219,5 +208,5 @@
                      &                    -zfm*xkr_mass_max**3*(1.+3.*((zeps-1.)/           &
                      &                    (zeps-2.)+(zeps-1.)/zdiv3)+(zeps-1.)/zdiv1))      &
-#    if defined key_off_degrad
+#    if defined key_degrad
                      &                 *facvol(ji,jj,jk)             &
 #    endif
@@ -225,5 +214,5 @@
 
                   zagg3 = (  0.163*trn(ji,jj,jk,jpnum)**2*zfm**2*8. * xkr_mass_max**3   &
-#    if defined key_off_degrad
+#    if defined key_degrad
                      &                 *facvol(ji,jj,jk)             &
 #    endif
@@ -232,7 +221,7 @@
                   zaggsh = ( zagg1 + zagg2 + zagg3 ) * rfact2 * xdiss(ji,jj,jk) / 1000.
 
-!    Aggregation of small into large particles
-!    Part II : Differential settling
-!    ----------------------------------------------
+                 !    Aggregation of small into large particles
+                 !    Part II : Differential settling
+                 !    ----------------------------------------------
 
                   zagg4 = (  2.*3.141*0.125*trn(ji,jj,jk,jpnum)**2*                       &
@@ -242,5 +231,5 @@
                      &                 ((zfm*zfm*xkr_mass_max**2*zsm-xkr_mass_min**2)     &
                      &                 *xkr_eta)/(zdiv*zdiv3*zdiv5) )                     &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)        &
 # endif
@@ -252,5 +241,5 @@
                      &                 /zdiv3-(xkr_mass_min**2-zfm*zsm*xkr_mass_max**2)    &
                      &                 /zdiv)                   &
-# if defined key_off_degrad
+# if defined key_degrad
                      &                 *facvol(ji,jj,jk)        &
 # endif
@@ -261,10 +250,10 @@
                   zagg = 0.5 * xkr_stick * ( zaggsh + zaggsi )
 
-!     Aggregation of DOC to small particles
-!     --------------------------------------
+                  !     Aggregation of DOC to small particles
+                  !     --------------------------------------
 
                   zaggdoc = ( 0.4 * trn(ji,jj,jk,jpdoc)               &
                      &        + 1018.  * trn(ji,jj,jk,jppoc)  ) * xstep    &
-# if defined key_off_degrad
+# if defined key_degrad
                      &        * facvol(ji,jj,jk)                              &
 # endif
@@ -281,5 +270,5 @@
       END DO
 
-#if defined key_trc_diaadd
+#if defined key_diatrc
       zrfact2 = 1.e3 * rfact2r
       ik1 = iksed + 1
@@ -332,5 +321,5 @@
       !!
       !! ** Method  :   Read the nampiskrs namelist and check the parameters
-      !!      called at the first timestep (nittrc000)
+      !!      called at the first timestep 
       !!
       !! ** input   :   Namelist nampiskrs
@@ -473,6 +462,6 @@
       REAL(wp) ::   zagg1, zagg2, zagg3, zagg4
       REAL(wp) ::   zagg , zaggfe, zaggdoc, zaggdoc2
-      REAL(wp) ::   zfact, zwsmax
-#if defined key_trc_dia3d
+      REAL(wp) ::   zfact, zwsmax, zstep
+#if defined key_diatrc
       REAL(wp) ::   zrfact2
       INTEGER  ::   ik1
@@ -481,16 +470,11 @@
       !!---------------------------------------------------------------------
 
-      IF( ( kt * jnt ) == nittrc000  )  THEN
-          xstep  = rfact2 / rday      ! Timestep duration for biology
-          xstep2 = rfact2 /  2.
-      ENDIF
-
-!    Sinking speeds of detritus is increased with depth as shown
-!    by data and from the coagulation theory
-!    -----------------------------------------------------------
+      !    Sinking speeds of detritus is increased with depth as shown
+      !    by data and from the coagulation theory
+      !    -----------------------------------------------------------
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji=1,jpi
-               zfact = MAX( 0., fsdepw(ji,jj,jk+1)-hmld(ji,jj) ) / 4000.
+               zfact = MAX( 0., fsdepw(ji,jj,jk+1) - hmld(ji,jj) ) / 4000.
                wsbio4(ji,jj,jk) = wsbio2 + ( 200.- wsbio2 ) * zfact
             END DO
@@ -498,15 +482,13 @@
       END DO
 
-!      LIMIT THE VALUES OF THE SINKING SPEEDS 
-!      TO AVOID NUMERICAL INSTABILITIES
-
+      ! limit the values of the sinking speeds to avoid numerical instabilities  
       wsbio3(:,:,:) = wsbio
-!
-! OA Below, this is garbage. the ideal would be to find a time-splitting
-! OA algorithm that does not increase the computing cost by too much
-! OA In ROMS, I have included a time-splitting procedure. But it is 
-! OA too expensive as the loop is computed globally. Thus, a small e3t
-! OA at one place determines the number of subtimesteps globally
-! OA AWFULLY EXPENSIVE !! Not able to find a better approach. Damned !!
+      !
+      ! OA Below, this is garbage. the ideal would be to find a time-splitting 
+      ! OA algorithm that does not increase the computing cost by too much
+      ! OA In ROMS, I have included a time-splitting procedure. But it is 
+      ! OA too expensive as the loop is computed globally. Thus, a small e3t
+      ! OA at one place determines the number of subtimesteps globally
+      ! OA AWFULLY EXPENSIVE !! Not able to find a better approach. Damned !!
 
       DO jk = 1,jpkm1
@@ -522,6 +504,6 @@
       wscal(:,:,:) = wsbio4(:,:,:)
 
-!   INITIALIZE TO ZERO ALL THE SINKING ARRAYS
-!   -----------------------------------------
+      !  Initializa to zero all the sinking arrays 
+      !   -----------------------------------------
 
       sinking (:,:,:) = 0.e0
@@ -532,7 +514,6 @@
       sinkfer2(:,:,:) = 0.e0
 
-!   Compute the sedimentation term using p4zsink2 for all
-!   the sinking particles
-!   -----------------------------------------------------
+      !   Compute the sedimentation term using p4zsink2 for all the sinking particles
+      !   -----------------------------------------------------
 
       CALL p4z_sink2( wsbio3, sinking , jppoc )
@@ -543,45 +524,33 @@
       CALL p4z_sink2( wscal , sinkcal , jpcal )
 
-!  Exchange between organic matter compartments due to
-!  coagulation/disaggregation
-!  ---------------------------------------------------
+      !  Exchange between organic matter compartments due to coagulation/disaggregation
+      !  ---------------------------------------------------
 
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zfact = xstep * xdiss(ji,jj,jk)
+# if defined key_degrad
+               zstep = xstep * facvol(ji,jj,jk)
+# else
+               zstep = xstep 
+# endif
+               zfact = zstep * xdiss(ji,jj,jk)
                !  Part I : Coagulation dependent on turbulence
-# if defined key_off_degrad
-               zagg1 = 940.* zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
-               zagg2 = 1.054e4 * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
-# else
                zagg1 = 940.* zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
                zagg2 = 1.054e4 * zfact * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
-# endif
 
                ! Part II : Differential settling
 
                !  Aggregation of small into large particles
-# if defined key_off_degrad
-               zagg3 = 0.66 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc) * facvol(ji,jj,jk)
-               zagg4 = 0.e0 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc) * facvol(ji,jj,jk)
-# else
-               zagg3 = 0.66 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
-               zagg4 = 0.e0 * xstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
-# endif
+               zagg3 = 0.66 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jpgoc)
+               zagg4 = 0.e0 * zstep * trn(ji,jj,jk,jppoc) * trn(ji,jj,jk,jppoc)
+
                zagg   = zagg1 + zagg2 + zagg3 + zagg4
                zaggfe = zagg * trn(ji,jj,jk,jpsfe) / ( trn(ji,jj,jk,jppoc) + rtrn )
 
                ! Aggregation of DOC to small particles
-#if defined key_off_degrad
-               zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) )       &
-                  &      * facvol(ji,jj,jk)  * zfact * trn(ji,jj,jk,jpdoc)
-               zaggdoc2 = 1.05e4 * zfact * trn(ji,jj,jk,jpgoc)   &
-                  &      * facvol(ji,jj,jk) * trn(ji,jj,jk,jpdoc)
-#else
-               zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) )    &
-                  &      *  zfact * trn(ji,jj,jk,jpdoc)
+               zaggdoc = ( 80.* trn(ji,jj,jk,jpdoc) + 698. * trn(ji,jj,jk,jppoc) ) *  zfact * trn(ji,jj,jk,jpdoc) 
                zaggdoc2 = 1.05e4 * zfact * trn(ji,jj,jk,jpgoc) * trn(ji,jj,jk,jpdoc)
-#endif
+
                !  Update the trends
                tra(ji,jj,jk,jppoc) = tra(ji,jj,jk,jppoc) - zagg + zaggdoc
@@ -595,5 +564,5 @@
       END DO
 
-#if defined key_trc_diaadd
+#if defined key_diatrc
       zrfact2 = 1.e3 * rfact2r
       ik1  = iksed + 1
@@ -623,4 +592,10 @@
    END SUBROUTINE p4z_sink
 
+   SUBROUTINE p4z_sink_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE p4z_sink_init  ***
+      !!----------------------------------------------------------------------
+   END SUBROUTINE p4z_sink_init
+
 #endif
 
@@ -641,5 +616,5 @@
       !!
       INTEGER  ::   ji, jj, jk, jn
-      REAL(wp) ::   zigma,zew,zign, zflx
+      REAL(wp) ::   zigma,zew,zign, zflx, zstep
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztraz, zakz
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwsink2
@@ -647,9 +622,11 @@
 
 
+      zstep = rfact2 / 2.
+
       ztraz(:,:,:) = 0.e0
       zakz (:,:,:) = 0.e0
 
       DO jk = 1, jpkm1
-# if defined key_off_degrad
+# if defined key_degrad
          zwsink2(:,:,jk+1) = -pwsink(:,:,jk) / rday * tmask(:,:,jk+1) * facvol(:,:,jk)
 # else
@@ -693,7 +670,7 @@
             DO jj = 1, jpj      
                DO ji = 1, jpi    
-                  zigma = zwsink2(ji,jj,jk+1) * xstep2 / fse3w(ji,jj,jk+1)
+                  zigma = zwsink2(ji,jj,jk+1) * zstep / fse3w(ji,jj,jk+1)
                   zew   = zwsink2(ji,jj,jk+1)
-                  psinkflx(ji,jj,jk+1) = -zew * ( trn(ji,jj,jk,jp_tra) - 0.5 * ( 1 + zigma ) * zakz(ji,jj,jk) ) * xstep2
+                  psinkflx(ji,jj,jk+1) = -zew * ( trn(ji,jj,jk,jp_tra) - 0.5 * ( 1 + zigma ) * zakz(ji,jj,jk) ) * zstep
                END DO
             END DO
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/par_pisces.F90	(revision 2528)
@@ -6,7 +6,7 @@
    !! History :   2.0  !  2007-12  (C. Ethe, G. Madec)  revised architecture
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
    USE par_lobster, ONLY : jp_lobster      !: number of tracers in LOBSTER
@@ -17,8 +17,8 @@
    IMPLICIT NONE
 
-   INTEGER, PARAMETER ::   jp_lp      = jp_lobster      !: cumulative number of already defined TRC
-   INTEGER, PARAMETER ::   jp_lp_2d   = jp_lobster_2d   !:
-   INTEGER, PARAMETER ::   jp_lp_3d   = jp_lobster_3d   !:
-   INTEGER, PARAMETER ::   jp_lp_trd  = jp_lobster_trd  !:
+   INTEGER, PUBLIC, PARAMETER ::   jp_lp      = jp_lobster      !: cumulative number of already defined TRC
+   INTEGER, PUBLIC, PARAMETER ::   jp_lp_2d   = jp_lobster_2d   !:
+   INTEGER, PUBLIC, PARAMETER ::   jp_lp_3d   = jp_lobster_3d   !:
+   INTEGER, PUBLIC, PARAMETER ::   jp_lp_trd  = jp_lobster_trd  !:
 
 #if defined key_pisces  &&  defined key_kriest
@@ -29,6 +29,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .TRUE.  !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     =  23     !: number of passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output ('key_trc_diaadd')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  =  13     !: additional 2d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  =  18     !: additional 3d output ('key_diatrc')
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =   1     !: number of sms trends for PISCES
 
@@ -67,6 +67,6 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_kriest     = .FALSE. !: Kriest flag 
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces     = 24      !: number of PISCES passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output ('key_trc_diaadd')
-   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output ('key_trc_diaadd')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_2d  = 13      !: additional 2d output ('key_diatrc')
+   INTEGER, PUBLIC, PARAMETER ::   jp_pisces_3d  = 11      !: additional 3d output ('key_diatrc')
    INTEGER, PUBLIC, PARAMETER ::   jp_pisces_trd =  1      !: number of sms trends for PISCES
 
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2528)
@@ -23,4 +23,5 @@
    REAL(wp) ::   rfact , rfactr    !: ???
    REAL(wp) ::   rfact2, rfact2r   !: ???
+   REAL(wp) ::   xstep             !: Time step duration for biology
 
    !!*  Biological parameters 
@@ -62,5 +63,5 @@
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimbac    !: ??
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiss      !: ??
-#if defined key_trc_dia3d
+#if defined key_diatrc
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prodcal    !: Calcite production
    REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazing    !: Total zooplankton grazing
@@ -91,7 +92,7 @@
    
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================   
 END MODULE sms_pisces    
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2528)
@@ -40,7 +40,7 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -55,17 +55,20 @@
 
 
+      !  Control consitency
+      CALL trc_ctl_pisces
+
+
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' trc_ini_pisces :   PISCES biochemical model initialisation'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
 
-
       !                                            ! Time-step
-      rfact   = rdttra(1) * float(ndttrc)          ! ---------
+      rfact   = rdttrc(1)                          ! ---------
       rfactr  = 1. / rfact
-      rfact2  = rfact / float(nrdttrc)
+      rfact2  = rfact / FLOAT( nrdttrc )
       rfact2r = 1. / rfact2
 
-      IF(lwp) WRITE(numout,*) '    Tracer  time step    rfact  = ', rfact, ' rdt = ', rdt
-      IF(lwp) write(numout,*) '    Biology time step    rfact2 = ', rfact2
+      IF(lwp) WRITE(numout,*) '    Passive Tracer  time step    rfact  = ', rfact, ' rdt = ', rdttra(1)
+      IF(lwp) write(numout,*) '    PISCES  Biology time step    rfact2 = ', rfact2
 
 
@@ -80,6 +83,4 @@
 
       CALL p4z_che        ! initialize the chemical constants
-
-      ndayflxtr = 0      !  Initialize a counter for the computation of chemistry
 
       ! Initialization of tracer concentration in case of  no restart 
@@ -128,5 +129,25 @@
       !
    END SUBROUTINE trc_ini_pisces
-   
+ 
+   SUBROUTINE trc_ctl_pisces
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_ctl_pisces  ***
+      !!
+      !! ** Purpose :   control the cpp options, namelist and files 
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' use PISCES biological model '
+
+   ! Check number of tracers
+   ! -----------------------
+#if  defined key_kriest
+      IF( jp_pisces /= 23) CALL ctl_stop( ' PISCES must have 23 passive tracers. Change jp_pisces in par_pisces.F90' )
+#else
+      IF( jp_pisces /= 24) CALL ctl_stop( ' PISCES must have 24 passive tracers. Change jp_pisces in par_pisces.F90' )
+#endif
+
+   END SUBROUTINE trc_ctl_pisces
+  
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2528)
@@ -0,0 +1,207 @@
+MODULE trcnam_pisces
+   !!======================================================================
+   !!                      ***  MODULE trcnam_lobster  ***
+   !! TOP :   initialisation of some run parameters for PISCES bio-model
+   !!======================================================================
+   !! History :    -   !  1999-10 (M.A. Foujols, M. Levy) original code
+   !!              -   !  2000-01 (L. Bopp) hamocc3, p3zd
+   !!             1.0  !  2003-08 (C. Ethe)  module F90
+   !!             2.0  !  2007-12  (C. Ethe, G. Madec) from trcnam.pisces.h90
+   !!----------------------------------------------------------------------
+#if defined key_pisces
+   !!----------------------------------------------------------------------
+   !!   'key_pisces'   :                                   PISCES bio-model
+   !!----------------------------------------------------------------------
+   !! trc_nam_pisces       : PISCES model namelist read
+   !!----------------------------------------------------------------------
+   USE oce_trc         ! Ocean variables
+   USE par_trc         ! TOP parameters
+   USE trc             ! TOP variables
+   USE sms_pisces      ! sms trends
+   USE in_out_manager  ! I/O manager
+
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trc_nam_pisces   ! called by trcnam.F90 module
+
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trc_nam_pisces
+      !!----------------------------------------------------------------------
+      !!                     ***  trc_nam_pisces  ***  
+      !!
+      !! ** Purpose :   read PISCES namelist
+      !!
+      !! ** input   :   file 'namelist.trc.sms' containing the following
+      !!             namelist: natext, natbio, natsms
+      !!                       natkriest ("key_kriest")
+      !!----------------------------------------------------------------------
+      !!
+#if defined key_diatrc && ! defined key_iomput
+      INTEGER ::  jl, jn
+      ! definition of additional diagnostic as a structure
+      TYPE DIAG
+         CHARACTER(len = 20)  :: snamedia   !: short name
+         CHARACTER(len = 80 ) :: lnamedia   !: long name
+         CHARACTER(len = 20 ) :: unitdia    !: unit
+      END TYPE DIAG
+
+      TYPE(DIAG) , DIMENSION(jp_pisces_2d) :: pisdia2d
+      TYPE(DIAG) , DIMENSION(jp_pisces_3d) :: pisdia3d
+#endif
+
+      NAMELIST/nampisbio/ part, nrdttrc, wsbio, xkmort, ferat3, wsbio2
+#if defined key_kriest
+      NAMELIST/nampiskrp/ xkr_eta, xkr_zeta, xkr_mass_min, xkr_mass_max
+#endif
+#if defined key_diatrc && ! defined key_iomput
+      NAMELIST/nampisdia/ nwritedia, pisdia3d, pisdia2d     ! additional diagnostics
+#endif
+      NAMELIST/nampisdmp/ ln_pisdmp, ln_pisclo
+
+      !!----------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' trc_nam_pisces : read PISCES namelists'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+
+      !                               ! Open the namelist file
+      !                               ! ----------------------
+      CALL ctl_opn( numnat, 'namelist_pisces', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+
+      REWIND( numnat )                    
+      READ  ( numnat, nampisbio )
+
+      IF(lwp) THEN                         ! control print
+         WRITE(numout,*) ' Namelist : nampisbio'
+         WRITE(numout,*) '    part of calcite not dissolved in guts     part      =', part
+         WRITE(numout,*) '    frequence pour la biologie                nrdttrc   =', nrdttrc
+         WRITE(numout,*) '    POC sinking speed                         wsbio     =', wsbio
+         WRITE(numout,*) '    half saturation constant for mortality    xkmort    =', xkmort
+         WRITE(numout,*) '    Fe/C in zooplankton                       ferat3    =', ferat3
+         WRITE(numout,*) '    Big particles sinking speed               wsbio2    =', wsbio2
+      ENDIF
+
+#if defined key_kriest
+
+      !                               ! nampiskrp : kriest parameters
+      !                               ! -----------------------------
+      xkr_eta      = 0.62        
+      xkr_zeta     = 1.62        
+      xkr_mass_min = 0.0002     
+      xkr_mass_max = 1.      
+
+      REWIND( numnat )                     ! read natkriest
+      READ  ( numnat, nampiskrp )
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : nampiskrp'
+         WRITE(numout,*) '    Sinking  exponent                        xkr_eta      = ', xkr_eta
+         WRITE(numout,*) '    N content exponent                       xkr_zeta     = ', xkr_zeta
+         WRITE(numout,*) '    Minimum mass for Aggregates              xkr_mass_min = ', xkr_mass_min
+         WRITE(numout,*) '    Maximum mass for Aggregates              xkr_mass_max = ', xkr_mass_max
+         WRITE(numout,*)
+     ENDIF
+
+
+     ! Computation of some variables
+     xkr_massp = 5.7E-6 * 7.6 * xkr_mass_min**xkr_zeta
+
+#endif
+      !
+#if defined key_diatrc && ! defined key_iomput
+
+      ! Namelist namlobdia
+      ! -------------------
+      nwritedia = 10                   ! default values
+
+      DO jl = 1, jp_pisces_2d
+         jn = jp_pcs0_2d + jl - 1
+         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
+         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc2u(jn) = ' '                                       ! units
+      END DO
+      !                                 ! 3D output arrays
+      DO jl = 1, jp_pisces_3d
+         jn = jp_pcs0_3d + jl - 1
+         WRITE(ctrc3d(jn),'("3D_",I1)') jn                      ! short name
+         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc3u(jn) = ' '                                       ! units
+      END DO
+
+      REWIND( numnat )               ! read natrtd
+      READ  ( numnat, nampisdia )
+
+      DO jl = 1, jp_pisces_2d
+         jn = jp_pcs0_2d + jl - 1
+         ctrc2d(jn) = pisdia2d(jl)%snamedia
+         ctrc2l(jn) = pisdia2d(jl)%lnamedia
+         ctrc2u(jn) = pisdia2d(jl)%unitdia
+      END DO
+
+      DO jl = 1, jp_pisces_3d
+         jn = jp_pcs0_3d + jl - 1
+         ctrc3d(jn) = pisdia3d(jl)%snamedia
+         ctrc3l(jn) = pisdia3d(jl)%lnamedia
+         ctrc3u(jn) = pisdia3d(jl)%unitdia
+      END DO
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : natadd'
+         WRITE(numout,*) '    frequency of outputs for additional arrays nwritedia = ', nwritedia
+         DO jl = 1, jp_pisces_3d
+            jn = jp_pcs0_3d + jl - 1
+            WRITE(numout,*) '   3d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
+            WRITE(numout,*) ' '
+         END DO
+
+         DO jl = 1, jp_pisces_2d
+            jn = jp_pcs0_2d + jl - 1
+            WRITE(numout,*) '   2d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+            WRITE(numout,*) ' '
+         END DO
+      ENDIF
+#endif
+
+      REWIND( numnat )
+      READ  ( numnat, nampisdmp )
+
+      IF(lwp) THEN                         ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : nampisdmp'
+         WRITE(numout,*) '    Relaxation of tracer to glodap mean value            ln_pisdmp      =', ln_pisdmp
+         WRITE(numout,*) '    Restoring of tracer to initial value  on closed seas  ln_pisclo      =', ln_pisclo
+         WRITE(numout,*) ' '
+      ENDIF
+
+   END SUBROUTINE trc_nam_pisces
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                   No PISCES bio-model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_nam_pisces                      ! Empty routine
+   END  SUBROUTINE  trc_nam_pisces
+#endif  
+
+   !!======================================================================
+END MODULE trcnam_pisces
